/*
 *    ​​ AnimeBeans: 2D Animation Software
    Copyright (C) 2015 Kenneth Dallmann

AnimeBeans license is the the GNU GPLv3, other than objects output of the Character class 
and the Drawable interface, those are under the MIT License included in this folder. Derivative 
works must be licensed using this license agreement, so when GPLv3 states “You must license the entire work,
as a whole, under this License to anyone who comes into possession of a copy” it actually means that 
you must license derivative works using this document. The MIT license gives more freedom to users of 
AnimeBeans to license their artwork or animations using any license they desire.  

This product has no guarantee of quality, USE AT YOUR OWN RISK.

 */

package art;


import java.io.Serializable;

/**
 * A simple linked queue.
 * @author Kenneth Dallmann
 * 
 * @param <T>
 */

public class Queue<T> implements Serializable{
private	T element;
private	Queue<T> front;
private Queue<T> back;
private	Queue<T> next;

	
	Queue(){
		front=this;
		back =this;
	}
	
	void enqueue(T e){
		if(e == null) return;
		
		back.element = e;
		back.next = new Queue<T>();
	back = back.next;
	}
	
	T dequeue(){
	T t = front.element;
	front = front.next;
	return t;
	}
	
	boolean contains(T item){
		Queue<T> t = front;
		while(t.element != null)
		{
			if(t.element == item)return true;
			t = t.next;
		}
		return false;
	}
	
	int getSize(){
		
		if(front.element == null)return 0;
		
		Queue<T> t = front;
		int s =1;
		do{
			if(t.next == null || t.next.element == null) return s;
			else{
			t = t.next;
			s++;}
		}while(t.element != null);
		
		return s;
	}
	
	boolean isEmpty(){
		if(peek() == null) return true;
		else return false;
	}
	
	T peek(){
		return front.element;
	}
	
}
	
	



